/*
 * This file is part of the Owl Positioning System (OwlPS) project.
 * It is subject to the copyright notice and license terms in the
 * COPYRIGHT.t2t file found in the top-level directory of this
 * distribution and at
 *   https://code.lm7.fr/mcy/owlps/src/master/COPYRIGHT.t2t
 * No part of the OwlPS Project, including this file, may be copied,
 * modified, propagated, or distributed except according to the terms
 * contained in the COPYRIGHT.t2t file; the COPYRIGHT.t2t file must be
 * distributed along with this file, either separately or by replacing
 * this notice by the COPYRIGHT.t2t file's contents.
 */


#ifndef _OWLPS_POSITIONING_OUTPUT_HH_
#define _OWLPS_POSITIONING_OUTPUT_HH_

class OutputMedium ;
class ResultList ;

#include <vector>

/// Handles the outputs
class Output
{
protected:
  /// List of output media used
  std::vector<OutputMedium*> output_media ;

  /** @name Operations */
  //@{
  void initialise_output_media(void) ;
  void initialise_output_terminal(void) ;
  void initialise_output_csv(void) ;
  void initialise_output_udp_socket(void) ;
  void initialise_output_tcpevaal_socket(void) ;
  //@}

public:
  Output(void) ;

  ~Output(void) ;

  /** @name Operations */
  //@{
  void write(const ResultList &results) const ;
  //@}
} ;

#endif // _OWLPS_POSITIONING_OUTPUT_HH_
